&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          rtb              PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
{adecomm/appserv.i}
DEFINE VARIABLE h_roundtable               AS HANDLE          NO-UNDO.
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS dTables 
/*------------------------------------------------------------------------

  File: rtb_u_tnot.w

  Description: SDO to update Roundtable task notes.

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: Randall K. Harp

  Created: March 2000

------------------------------------------------------------------------*/
/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE MnotationDesc AS CHARACTER  NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDataObject
&Scoped-define DB-AWARE yes

&Scoped-define ADM-SUPPORTED-LINKS Data-Source,Data-Target,Navigation-Target,Update-Target,Commit-Target,Filter-Target


/* Db-Required definitions. */
&IF DEFINED(DB-REQUIRED) = 0 &THEN
    &GLOBAL-DEFINE DB-REQUIRED TRUE
&ENDIF
&GLOBAL-DEFINE DB-REQUIRED-START   &IF {&DB-REQUIRED} &THEN
&GLOBAL-DEFINE DB-REQUIRED-END     &ENDIF


&Scoped-define QUERY-NAME Query-Main

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES rtb.rtb_tnot

/* Definitions for QUERY Query-Main                                     */
&Scoped-Define ENABLED-FIELDS  note-type note-status note-priority user-name entered-when compltd-by~
 compltd-when pmod object obj-type version act-hours est-hours task-num~
 notationDesc
&Scoped-define ENABLED-FIELDS-IN-rtb.rtb_tnot note-type note-status ~
note-priority user-name entered-when compltd-by compltd-when pmod object ~
obj-type version act-hours est-hours task-num 
&Scoped-Define DATA-FIELDS  note-type note-status note-priority user-name entered-when compltd-by~
 compltd-when pmod object obj-type version act-hours est-hours task-num~
 notationDesc
&Scoped-define DATA-FIELDS-IN-rtb.rtb_tnot note-type note-status ~
note-priority user-name entered-when compltd-by compltd-when pmod object ~
obj-type version act-hours est-hours task-num 
&Scoped-Define MANDATORY-FIELDS 
&Scoped-Define APPLICATION-SERVICE roundtable
&Scoped-Define ASSIGN-LIST 
&Scoped-Define DATA-FIELD-DEFS "rtb/sdo/rtb_u_tnot.i"
&Scoped-define QUERY-STRING-Query-Main FOR EACH rtb.rtb_tnot NO-LOCK INDEXED-REPOSITION
{&DB-REQUIRED-START}
&Scoped-define OPEN-QUERY-Query-Main OPEN QUERY Query-Main FOR EACH rtb.rtb_tnot NO-LOCK INDEXED-REPOSITION.
{&DB-REQUIRED-END}
&Scoped-define TABLES-IN-QUERY-Query-Main rtb.rtb_tnot
&Scoped-define FIRST-TABLE-IN-QUERY-Query-Main rtb.rtb_tnot


/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD addRow dTables 
FUNCTION addRow RETURNS CHARACTER
  ( INPUT pcViewColList AS CHARACTER)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fnRtbSelectTask dTables 
FUNCTION fnRtbSelectTask RETURNS LOGICAL
  ( INPUT Ptask-num AS INTEGER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

{&DB-REQUIRED-START}

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY Query-Main FOR 
      rtb.rtb_tnot SCROLLING.
&ANALYZE-RESUME
{&DB-REQUIRED-END}


/* ************************  Frame Definitions  *********************** */


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDataObject
   Allow: Query
   Frames: 0
   Add Fields to: Neither
   Partition: roundtable
   Other Settings: PERSISTENT-ONLY COMPILE APPSERVER DB-AWARE
 */

/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW dTables ASSIGN
         HEIGHT             = 1.62
         WIDTH              = 52.8.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB dTables 
/* ************************* Included-Libraries *********************** */

{rtb/admtwo/data.i}
{rtb/i/rtb_s_tnot.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW dTables
  VISIBLE,,RUN-PERSISTENT                                               */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK QUERY Query-Main
/* Query rebuild information for SmartDataObject Query-Main
     _TblList          = "rtb.rtb_tnot"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _FldNameList[1]   > rtb.rtb_tnot.note-type
"note-type" "note-type" ? ? "character" ? ? ? ? ? ? yes ? no 8 yes ""
     _FldNameList[2]   > rtb.rtb_tnot.note-status
"note-status" "note-status" ? ? "character" ? ? ? ? ? ? yes ? no 8 yes ""
     _FldNameList[3]   > rtb.rtb_tnot.note-priority
"note-priority" "note-priority" ? ? "integer" ? ? ? ? ? ? yes ? no 6.2 yes ""
     _FldNameList[4]   > rtb.rtb_tnot.user-name
"user-name" "user-name" ? ? "character" ? ? ? ? ? ? yes ? no 12 yes ""
     _FldNameList[5]   > rtb.rtb_tnot.entered-when
"entered-when" "entered-when" ? ? "date" ? ? ? ? ? ? yes ? no 13.8 yes ""
     _FldNameList[6]   > rtb.rtb_tnot.compltd-by
"compltd-by" "compltd-by" ? ? "character" ? ? ? ? ? ? yes ? no 13 yes ""
     _FldNameList[7]   > rtb.rtb_tnot.compltd-when
"compltd-when" "compltd-when" ? ? "date" ? ? ? ? ? ? yes ? no 16.4 yes ""
     _FldNameList[8]   > rtb.rtb_tnot.pmod
"pmod" "pmod" ? "x(20)" "character" ? ? ? ? ? ? yes ? no 20 no ""
     _FldNameList[9]   > rtb.rtb_tnot.object
"object" "object" ? ? "character" ? ? ? ? ? ? yes ? no 32 no ""
     _FldNameList[10]   > rtb.rtb_tnot.obj-type
"obj-type" "obj-type" ? ? "character" ? ? ? ? ? ? yes ? no 6 no ""
     _FldNameList[11]   > rtb.rtb_tnot.version
"version" "version" ? ? "integer" ? ? ? ? ? ? yes ? no 7.2 no ""
     _FldNameList[12]   > rtb.rtb_tnot.act-hours
"act-hours" "act-hours" ? ? "decimal" ? ? ? ? ? ? yes ? no 6.6 yes ""
     _FldNameList[13]   > rtb.rtb_tnot.est-hours
"est-hours" "est-hours" ? ? "decimal" ? ? ? ? ? ? yes ? no 6.6 yes ""
     _FldNameList[14]   > rtb.rtb_tnot.task-num
"task-num" "task-num" ? ? "integer" ? ? ? ? ? ? yes ? no 10.8 no ""
     _FldNameList[15]   > "_<CALC>"
"DYNAMIC-FUNCTION('fnRtbGetNotationDesc':U,to-rowid(RowObject.RowIdent))" "notationDesc" "Description" "x(8)" "character" ? ? ? ? ? ? yes ? no 10.6 no ?
     _Design-Parent    is WINDOW dTables @ ( 1.14 , 2.6 )
*/  /* QUERY Query-Main */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK dTables 


/* ***************************  Main Block  *************************** */

  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          
    RUN initializeObject.
  &ENDIF

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

{&DB-REQUIRED-START}

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE beginTransactionValidate dTables  _DB-REQUIRED
PROCEDURE beginTransactionValidate :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mi AS INTEGER NO-UNDO.

  DEFINE BUFFER Brtb_tnot FOR rtb.rtb_tnot.
  
  FOR EACH rowObjUpd:

    CASE rowObjUpd.rowMod:

    WHEN "A":U THEN DO:
      IF INDEX(rowObjUpd.changedFields,"notationDesc") GT 0 THEN DO:
        MnotationDesc = rowObjupd.notationDesc.
      END.
    END.

    WHEN "U":U THEN DO:
      IF INDEX(rowObjUpd.changedFields,"notationDesc") GT 0 THEN DO:
        FIND Brtb_tnot WHERE
             ROWID(Brtb_tnot) = TO-ROWID(rowObjUpd.rowIdent).
        DO Mi = 1 TO 15:
          IF Mi = 1 THEN
            Brtb_tnot.DESCRIPTION[Mi] = rowObjUpd.notationDesc.
          ELSE
            Brtb_tnot.DESCRIPTION[Mi] = "".
        END. /* Mi */
      END. /* if index.. */
    END. /* "U" */

    END CASE.

  END. /* each rowObjUpd */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

{&DB-REQUIRED-END}

{&DB-REQUIRED-START}

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DATA.CALCULATE dTables  DATA.CALCULATE _DB-REQUIRED
PROCEDURE DATA.CALCULATE :
/*------------------------------------------------------------------------------
  Purpose:     Calculate all the Calculated Expressions found in the
               SmartDataObject.
  Parameters:  <none>
------------------------------------------------------------------------------*/
      ASSIGN 
         rowObject.notationDesc = (DYNAMIC-FUNCTION('fnRtbGetNotationDesc':U,to-rowid(RowObject.RowIdent)))
      .

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

{&DB-REQUIRED-END}

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI dTables  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

{&DB-REQUIRED-START}

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE endTransactionValidate dTables  _DB-REQUIRED
PROCEDURE endTransactionValidate :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  
  FOR EACH rowObjUpd:

    CASE rowObjUpd.rowMod:

    WHEN "A":U THEN DO:
      IF INDEX(rowObjUpd.changedFields,"notationDesc") GT 0 THEN DO:
        FIND rtb.rtb_tnot WHERE 
             ROWID(rtb.rtb_tnot) = TO-ROWID(RowObjUpd.rowIdent).
        rtb.rtb_tnot.DESCRIPTION[1] = MnotationDesc.
      END. /* if index.. */
    END. /* "A" */

    END CASE.

  END. /* each rowObjUpd */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

{&DB-REQUIRED-END}

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rowObjectValidate dTables 
PROCEDURE rowObjectValidate :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  
  IF rowObject.task-num = 0 THEN
    RETURN "Task notation must have a valid task number.".

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION addRow dTables 
FUNCTION addRow RETURNS CHARACTER
  ( INPUT pcViewColList AS CHARACTER) :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Notes:       Populate the task-num field with the current task.
------------------------------------------------------------------------------*/
  DEFINE VARIABLE MreturnString AS CHARACTER NO-UNDO.
  DEFINE VARIABLE McurrentTask  AS INTEGER   NO-UNDO.
  DEFINE VARIABLE MfieldPos     AS INTEGER   NO-UNDO.

  PUBLISH "evRtbGetCurrentTask" (OUTPUT McurrentTask).

  MfieldPos = LOOKUP('task-num':U, pcViewColList).
  
  MreturnString = SUPER(pcViewColList).

  IF MfieldPos <> 0 THEN
    ENTRY(MfieldPos + 1, MreturnString, CHR(1)) = STRING(McurrentTask).

  RETURN MreturnString.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fnRtbSelectTask dTables 
FUNCTION fnRtbSelectTask RETURNS LOGICAL
  ( INPUT Ptask-num AS INTEGER ) :
/*------------------------------------------------------------------------------
  Purpose:  Select all the task notations for a task number.
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Mwhere AS CHARACTER   NO-UNDO.

  Mwhere = SUBSTITUTE("rtb.rtb_tnot.task-num = &1", Ptask-num).
      
  DYNAMIC-FUNCTION('closeQuery':U).
  DYNAMIC-FUNCTION('setQueryWhere':U, INPUT Mwhere).
  DYNAMIC-FUNCTION('openQuery':U).

  RETURN TRUE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

